(function() {
  var compress_js, eco, fs, inspect, options, puts, say, set_options, stitch, uglify, _, _ref;
  var __slice = Array.prototype.slice;
  _ref = require('sys'), puts = _ref.puts, inspect = _ref.inspect;
  _ = require('underscore')._;
  stitch = require('./stitch');
  uglify = require('uglify-js');
  eco = require('eco');
  fs = require('fs');
  options = {
    quiet: false,
    compress: false
  };
  say = function(msg) {
    if (!options.quiet) {
      return puts(msg);
    }
  };
  set_options = function(opts) {
    return options = _.extend(options, opts);
  };
  compress_js = function(source, callback) {
    var ast, compressed_source, jsp, pro;
    compressed_source = options.compress ? (jsp = uglify.parser, pro = uglify.uglify, ast = jsp.parse(source), ast = pro.ast_mangle(ast), ast = pro.ast_squeeze(ast), pro.gen_code(ast)) : source;
    return callback(compressed_source);
  };
  _(exports).extend({
    js: function() {
      var callback, localOpts, opts, package, paths, _i;
      paths = arguments[0], opts = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), callback = arguments[_i++];
      localOpts = opts[0] || {};
      package = stitch.createPackage({
        paths: paths,
        identifier: localOpts.identifier || 'require',
        compilers: {
          eco: function(module, filename) {
            var content, template;
            content = fs.readFileSync(filename);
            template = eco.compile(content.toString());
            return module._compile(template, filename);
          }
        }
      });
      return package.compile(function(err, js) {
        if (err) {
          return callback(err, null);
        } else {
          return compress_js(js, function(final_js) {
            return callback(false, final_js);
          });
        }
      });
    },
    css: function() {
      var callback, opts, package, path, _i;
      path = arguments[0], opts = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), callback = arguments[_i++];
      package = stitch.createCssPackage({
        paths: [path]
      });
      return package.compile(function(err, css) {
        return callback(err, css);
      });
    },
    setOptions: function(opts) {
      return set_options(opts);
    },
    compressJs: function(source, callback) {
      return compress_js(source, callback);
    }
  });
}).call(this);
